Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageUSB.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageUSB.cpp	(revision 18778)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageUSB.cpp	(revision 18779)
@@ -184,5 +184,5 @@
     USBFilterCmd cmd;
 
-    /* at least: 0: command, 1: index, 2: -target, 3: <target value> */
+    /* at least: 0: command, 1: index, 2: --target, 3: <target value> */
     if (a->argc < 4)
         return errorSyntax(USAGE_USBFILTER, "Not enough parameters");
@@ -190,7 +190,7 @@
     /* which command? */
     cmd.mAction = USBFilterCmd::Invalid;
-    if      (strcmp (a->argv [0], "add") == 0)     cmd.mAction = USBFilterCmd::Add;
-    else if (strcmp (a->argv [0], "modify") == 0)  cmd.mAction = USBFilterCmd::Modify;
-    else if (strcmp (a->argv [0], "remove") == 0)  cmd.mAction = USBFilterCmd::Remove;
+    if      (!strcmp(a->argv[0], "add"))     cmd.mAction = USBFilterCmd::Add;
+    else if (!strcmp(a->argv[0], "modify"))  cmd.mAction = USBFilterCmd::Modify;
+    else if (!strcmp(a->argv[0], "remove"))  cmd.mAction = USBFilterCmd::Remove;
 
     if (cmd.mAction == USBFilterCmd::Invalid)
@@ -206,5 +206,5 @@
         case USBFilterCmd::Modify:
         {
-            /* at least: 0: command, 1: index, 2: -target, 3: <target value>, 4: -name, 5: <name value> */
+            /* at least: 0: command, 1: index, 2: --target, 3: <target value>, 4: --name, 5: <name value> */
             if (a->argc < 6)
             {
@@ -223,10 +223,11 @@
             for (int i = 2; i < a->argc; i++)
             {
-                if  (strcmp(a->argv [i], "-target") == 0)
+                if (   !strcmp(a->argv[i], "--target")
+                    || !strcmp(a->argv[i], "-target"))
                 {
                     if (a->argc <= i + 1 || !*a->argv[i+1])
                         return errorArgument("Missing argument to '%s'", a->argv[i]);
                     i++;
-                    if (strcmp (a->argv [i], "global") == 0)
+                    if (!strcmp(a->argv[i], "global"))
                         cmd.mGlobal = true;
                     else
@@ -241,59 +242,67 @@
                     }
                 }
-                else if (strcmp(a->argv [i], "-name") == 0)
+                else if (   !strcmp(a->argv[i], "--name")
+                         || !strcmp(a->argv[i], "-name"))
                 {
                     if (a->argc <= i + 1 || !*a->argv[i+1])
                         return errorArgument("Missing argument to '%s'", a->argv[i]);
                     i++;
-                    cmd.mFilter.mName = a->argv [i];
-                }
-                else if (strcmp(a->argv [i], "-active") == 0)
-                {
-                    if (a->argc <= i + 1)
-                        return errorArgument("Missing argument to '%s'", a->argv[i]);
-                    i++;
-                    if (strcmp (a->argv [i], "yes") == 0)
+                    cmd.mFilter.mName = a->argv[i];
+                }
+                else if (   !strcmp(a->argv[i], "--active")
+                         || !strcmp(a->argv[i], "-active"))
+                {
+                    if (a->argc <= i + 1)
+                        return errorArgument("Missing argument to '%s'", a->argv[i]);
+                    i++;
+                    if (!strcmp(a->argv[i], "yes"))
                         cmd.mFilter.mActive = true;
-                    else if (strcmp (a->argv [i], "no") == 0)
+                    else if (!strcmp(a->argv[i], "no"))
                         cmd.mFilter.mActive = false;
                     else
-                        return errorArgument("Invalid -active argument '%s'", a->argv[i]);
-                }
-                else if (strcmp(a->argv [i], "-vendorid") == 0)
-                {
-                    if (a->argc <= i + 1)
-                        return errorArgument("Missing argument to '%s'", a->argv[i]);
-                    i++;
-                    cmd.mFilter.mVendorId = a->argv [i];
-                }
-                else if (strcmp(a->argv [i], "-productid") == 0)
-                {
-                    if (a->argc <= i + 1)
-                        return errorArgument("Missing argument to '%s'", a->argv[i]);
-                    i++;
-                    cmd.mFilter.mProductId = a->argv [i];
-                }
-                else if (strcmp(a->argv [i], "-revision") == 0)
-                {
-                    if (a->argc <= i + 1)
-                        return errorArgument("Missing argument to '%s'", a->argv[i]);
-                    i++;
-                    cmd.mFilter.mRevision = a->argv [i];
-                }
-                else if (strcmp(a->argv [i], "-manufacturer") == 0)
-                {
-                    if (a->argc <= i + 1)
-                        return errorArgument("Missing argument to '%s'", a->argv[i]);
-                    i++;
-                    cmd.mFilter.mManufacturer = a->argv [i];
-                }
-                else if (strcmp(a->argv [i], "-product") == 0)
-                {
-                    if (a->argc <= i + 1)
-                        return errorArgument("Missing argument to '%s'", a->argv[i]);
-                    i++;
-                    cmd.mFilter.mProduct = a->argv [i];
-                }
-                else if (strcmp(a->argv [i], "-remote") == 0)
+                        return errorArgument("Invalid --active argument '%s'", a->argv[i]);
+                }
+                else if (   !strcmp(a->argv[i], "--vendorid")
+                         || !strcmp(a->argv[i], "-vendorid"))
+                {
+                    if (a->argc <= i + 1)
+                        return errorArgument("Missing argument to '%s'", a->argv[i]);
+                    i++;
+                    cmd.mFilter.mVendorId = a->argv[i];
+                }
+                else if (   !strcmp(a->argv[i], "--productid")
+                         || !strcmp(a->argv[i], "-productid"))
+                {
+                    if (a->argc <= i + 1)
+                        return errorArgument("Missing argument to '%s'", a->argv[i]);
+                    i++;
+                    cmd.mFilter.mProductId = a->argv[i];
+                }
+                else if (   !strcmp(a->argv[i], "--revision")
+                         || !strcmp(a->argv[i], "-revision"))
+                {
+                    if (a->argc <= i + 1)
+                        return errorArgument("Missing argument to '%s'", a->argv[i]);
+                    i++;
+                    cmd.mFilter.mRevision = a->argv[i];
+                }
+                else if (   !strcmp(a->argv[i], "--manufacturer")
+                         || !strcmp(a->argv[i], "-manufacturer"))
+                {
+                    if (a->argc <= i + 1)
+                        return errorArgument("Missing argument to '%s'", a->argv[i]);
+                    i++;
+                    cmd.mFilter.mManufacturer = a->argv[i];
+                }
+                else if (   !strcmp(a->argv[i], "--product")
+                         || !strcmp(a->argv[i], "-product"))
+                {
+                    if (a->argc <= i + 1)
+                        return errorArgument("Missing argument to '%s'", a->argv[i]);
+                    i++;
+                    cmd.mFilter.mProduct = a->argv[i];
+                }
+                else if (   !strcmp(a->argv[i], "--remote")
+                         || !strcmp(a->argv[i], "-remote"))
                 {
                     if (a->argc <= i + 1)
@@ -302,12 +311,14 @@
                     cmd.mFilter.mRemote = a->argv[i];
                 }
-                else if (strcmp(a->argv [i], "-serialnumber") == 0)
-                {
-                    if (a->argc <= i + 1)
-                        return errorArgument("Missing argument to '%s'", a->argv[i]);
-                    i++;
-                    cmd.mFilter.mSerialNumber = a->argv [i];
-                }
-                else if (strcmp(a->argv [i], "-maskedinterfaces") == 0)
+                else if (   !strcmp(a->argv[i], "--serialnumber")
+                         || !strcmp(a->argv[i], "-serialnumber"))
+                {
+                    if (a->argc <= i + 1)
+                        return errorArgument("Missing argument to '%s'", a->argv[i]);
+                    i++;
+                    cmd.mFilter.mSerialNumber = a->argv[i];
+                }
+                else if (   !strcmp(a->argv[i], "--maskedinterfaces")
+                         || !strcmp(a->argv[i], "-maskedinterfaces"))
                 {
                     if (a->argc <= i + 1)
@@ -317,15 +328,16 @@
                     rc = RTStrToUInt32Full(a->argv[i], 0, &u32);
                     if (RT_FAILURE(rc))
-                        return errorArgument("Failed to convert the -maskedinterfaces value '%s' to a number, rc=%Rrc", a->argv[i], rc);
+                        return errorArgument("Failed to convert the --maskedinterfaces value '%s' to a number, rc=%Rrc", a->argv[i], rc);
                     cmd.mFilter.mMaskedInterfaces = u32;
                 }
-                else if (strcmp(a->argv [i], "-action") == 0)
-                {
-                    if (a->argc <= i + 1)
-                        return errorArgument("Missing argument to '%s'", a->argv[i]);
-                    i++;
-                    if (strcmp (a->argv [i], "ignore") == 0)
+                else if (   !strcmp(a->argv[i], "--action")
+                         || !strcmp(a->argv[i], "-action"))
+                {
+                    if (a->argc <= i + 1)
+                        return errorArgument("Missing argument to '%s'", a->argv[i]);
+                    i++;
+                    if (!strcmp(a->argv[i], "ignore"))
                         cmd.mFilter.mAction = USBDeviceFilterAction_Ignore;
-                    else if (strcmp (a->argv [i], "hold") == 0)
+                    else if (!strcmp(a->argv[i], "hold"))
                         cmd.mFilter.mAction = USBDeviceFilterAction_Hold;
                     else
@@ -359,5 +371,5 @@
         case USBFilterCmd::Remove:
         {
-            /* at least: 0: command, 1: index, 2: -target, 3: <target value> */
+            /* at least: 0: command, 1: index, 2: --target, 3: <target value> */
             if (a->argc < 4)
                 return errorSyntax(USAGE_USBFILTER_REMOVE, "Not enough parameters");
@@ -365,10 +377,11 @@
             for (int i = 2; i < a->argc; i++)
             {
-                if  (strcmp(a->argv [i], "-target") == 0)
+                if (   !strcmp(a->argv[i], "--target")
+                    || !strcmp(a->argv[i], "-target"))
                 {
                     if (a->argc <= i + 1 || !*a->argv[i+1])
                         return errorArgument("Missing argument to '%s'", a->argv[i]);
                     i++;
-                    if (strcmp (a->argv [i], "global") == 0)
+                    if (!strcmp(a->argv[i], "global"))
                         cmd.mGlobal = true;
                     else