Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp	(revision 18828)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp	(revision 18829)
@@ -694,5 +694,5 @@
                     {
                         Bstr strBridgeAdp;
-                        nic->COMGETTER(BridgedInterface)(strBridgeAdp.asOutParam());
+                        nic->COMGETTER(HostInterface)(strBridgeAdp.asOutParam());
                         if (details == VMINFO_MACHINEREADABLE)
                         {
@@ -721,5 +721,5 @@
                     {
                         Bstr strHostonlyAdp;
-                        nic->COMGETTER(HostOnlyInterface)(strHostonlyAdp.asOutParam());
+                        nic->COMGETTER(HostInterface)(strHostonlyAdp.asOutParam());
                         if (details == VMINFO_MACHINEREADABLE)
                         {
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 18828)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 18829)
@@ -130,6 +130,5 @@
     std::vector <char *> nictracefile (NetworkAdapterCount, 0);
     std::vector <char *> nicspeed (NetworkAdapterCount, 0);
-    std::vector <char *> bridgedifdev (NetworkAdapterCount, 0);
-    std::vector <char *> hostonlyifdev (NetworkAdapterCount, 0);
+    std::vector <char *> hostifdev (NetworkAdapterCount, 0);
     std::vector <const char *> intnet (NetworkAdapterCount, 0);
     std::vector <const char *> natnet (NetworkAdapterCount, 0);
@@ -489,5 +488,5 @@
             if (a->argc <= i + 1)
                 return errorArgument("Missing argument to '%s'", a->argv[i]);
-            bridgedifdev[n - 1] = a->argv[i + 1];
+            hostifdev[n - 1] = a->argv[i + 1];
             i++;
         }
@@ -500,5 +499,5 @@
             if (a->argc <= i + 1)
                 return errorArgument("Missing argument to '%s'", a->argv[i]);
-            bridgedifdev[n - 1] = a->argv[i + 1];
+            hostifdev[n - 1] = a->argv[i + 1];
             i++;
         }
@@ -512,5 +511,5 @@
             if (a->argc <= i + 1)
                 return errorArgument("Missing argument to '%s'", a->argv[i]);
-            hostonlyifdev[n - 1] = a->argv[i + 1];
+            hostifdev[n - 1] = a->argv[i + 1];
             i++;
         }
@@ -1644,27 +1643,14 @@
 
             /* the host interface device? */
-            if (hostonlyifdev[n])
+            if (hostifdev[n])
             {
                 /* remove it? */
-                if (!strcmp(hostonlyifdev[n], "none"))
-                {
-                    CHECK_ERROR_RET(nic, COMSETTER(HostOnlyInterface)(NULL), 1);
+                if (!strcmp(hostifdev[n], "none"))
+                {
+                    CHECK_ERROR_RET(nic, COMSETTER(HostInterface)(NULL), 1);
                 }
                 else
                 {
-                    CHECK_ERROR_RET(nic, COMSETTER(HostOnlyInterface)(Bstr(hostonlyifdev[n])), 1);
-                }
-            }
-
-            if (bridgedifdev[n])
-            {
-                /* remove it? */
-                if (!strcmp(bridgedifdev[n], "none"))
-                {
-                    CHECK_ERROR_RET(nic, COMSETTER(BridgedInterface)(NULL), 1);
-                }
-                else
-                {
-                    CHECK_ERROR_RET(nic, COMSETTER(BridgedInterface)(Bstr(bridgedifdev[n])), 1);
+                    CHECK_ERROR_RET(nic, COMSETTER(HostInterface)(Bstr(hostifdev[n])), 1);
                 }
             }
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 18828)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 18829)
@@ -1898,5 +1898,5 @@
                     if (type == KNetworkAttachmentType_Bridged)
                         attType = attType.arg (tr ("Bridged network, %1",
-                            "details report (network)").arg (adapter.GetBridgedInterface()));
+                            "details report (network)").arg (adapter.GetHostInterface()));
                     else if (type == KNetworkAttachmentType_Internal)
                         attType = attType.arg (tr ("Internal network, '%1'",
@@ -1904,5 +1904,5 @@
                     else if (type == KNetworkAttachmentType_HostOnly)
                         attType = attType.arg (tr ("Host-only network, '%1'",
-                            "details report (network)").arg (adapter.GetHostOnlyInterface()));
+                            "details report (network)").arg (adapter.GetHostInterface()));
                     else
                         attType = attType.arg (vboxGlobal().toString (type));
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsNetworkDetails.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsNetworkDetails.cpp	(revision 18828)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsNetworkDetails.cpp	(revision 18829)
@@ -76,15 +76,11 @@
     if (!intName.isEmpty())
         setProperty ("INT_Name", QVariant (intName));
-    QString bridgedIfName (mAdapter.GetBridgedInterface());
-    CHostNetworkInterface bridgedIf =
-        vboxGlobal().virtualBox().GetHost().FindHostNetworkInterfaceByName (bridgedIfName);
-    if (!bridgedIf.isNull() && bridgedIf.GetInterfaceType() == KHostNetworkInterfaceType_Bridged)
-        setProperty ("BRG_Name", QVariant (bridgedIfName));
-
-    QString hostonlyIfName (mAdapter.GetHostOnlyInterface());
-    CHostNetworkInterface hostonlyIf =
-        vboxGlobal().virtualBox().GetHost().FindHostNetworkInterfaceByName (hostonlyIfName);
-    if (!hostonlyIf.isNull() && hostonlyIf.GetInterfaceType() == KHostNetworkInterfaceType_HostOnly)
-        setProperty ("HOI_Name", QVariant (hostonlyIfName));
+    QString ifsName (mAdapter.GetHostInterface());
+    CHostNetworkInterface ifs =
+        vboxGlobal().virtualBox().GetHost().FindHostNetworkInterfaceByName (ifsName);
+    if (!ifs.isNull() && ifs.GetInterfaceType() == KHostNetworkInterfaceType_Bridged)
+        setProperty ("BRG_Name", QVariant (ifsName));
+    else if (!ifs.isNull() && ifs.GetInterfaceType() == KHostNetworkInterfaceType_HostOnly)
+        setProperty ("HOI_Name", QVariant (ifsName));
 
     /* Load common settings */
@@ -100,5 +96,5 @@
     {
         case KNetworkAttachmentType_Bridged:
-            mAdapter.SetBridgedInterface (name);
+            mAdapter.SetHostInterface (name);
             break;
         case KNetworkAttachmentType_Internal:
@@ -106,5 +102,5 @@
             break;
         case KNetworkAttachmentType_HostOnly:
-            mAdapter.SetHostOnlyInterface (name);
+            mAdapter.SetHostInterface (name);
             break;
         default:
Index: trunk/src/VBox/Main/ApplianceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 18828)
+++ trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 18829)
@@ -2036,5 +2036,5 @@
                                 if (FAILED(rc)) throw rc;
                                 /* Set the interface name to attach to */
-                                pNetworkAdapter->COMSETTER(BridgedInterface)(name);
+                                pNetworkAdapter->COMSETTER(HostInterface)(name);
                                 if (FAILED(rc)) throw rc;
                                 break;
@@ -2067,5 +2067,5 @@
                                 if (FAILED(rc)) throw rc;
                                 /* Set the interface name to attach to */
-                                pNetworkAdapter->COMSETTER(HostOnlyInterface)(name);
+                                pNetworkAdapter->COMSETTER(HostInterface)(name);
                                 if (FAILED(rc)) throw rc;
                                 break;
Index: trunk/src/VBox/Main/ConsoleImpl.cpp
===================================================================
--- trunk/src/VBox/Main/ConsoleImpl.cpp	(revision 18828)
+++ trunk/src/VBox/Main/ConsoleImpl.cpp	(revision 18829)
@@ -4335,5 +4335,5 @@
                 /* a valid host interface must have been set */
                 Bstr hostif;
-                adapter->COMGETTER(BridgedInterface)(hostif.asOutParam());
+                adapter->COMGETTER(HostInterface)(hostif.asOutParam());
                 if (!hostif)
                 {
@@ -5735,5 +5735,5 @@
         /* The name of the TAP interface we are using */
         Bstr tapDeviceName;
-        rc = networkAdapter->COMGETTER(BridgedInterface)(tapDeviceName.asOutParam());
+        rc = networkAdapter->COMGETTER(HostInterface)(tapDeviceName.asOutParam());
         if (FAILED(rc))
             tapDeviceName.setNull();  /* Is this necessary? */
@@ -5856,5 +5856,5 @@
         Bstr tapDeviceName, tapTerminateApplication;
         bool isStatic = true;
-        rc = networkAdapter->COMGETTER(BridgedInterface)(tapDeviceName.asOutParam());
+        rc = networkAdapter->COMGETTER(HostInterface)(tapDeviceName.asOutParam());
         if (FAILED(rc) || tapDeviceName.isEmpty())
         {
Index: trunk/src/VBox/Main/ConsoleImpl2.cpp
===================================================================
--- trunk/src/VBox/Main/ConsoleImpl2.cpp	(revision 18828)
+++ trunk/src/VBox/Main/ConsoleImpl2.cpp	(revision 18829)
@@ -1238,5 +1238,5 @@
         }
 #ifdef VMWARE_NET_IN_SLOT_11
-        /*
+        /* 
          * Dirty hack for PCI slot compatibility with VMWare,
          * it assigns slot 11 to the first network controller.
@@ -1446,5 +1446,5 @@
 
                     Bstr HifName;
-                    hrc = networkAdapter->COMGETTER(BridgedInterface)(HifName.asOutParam());
+                    hrc = networkAdapter->COMGETTER(HostInterface)(HifName.asOutParam());
                     if(FAILED(hrc))
                     {
@@ -1808,5 +1808,5 @@
 # else
                 Bstr HifName;
-                hrc = networkAdapter->COMGETTER(HostOnlyInterface)(HifName.asOutParam());
+                hrc = networkAdapter->COMGETTER(HostInterface)(HifName.asOutParam());
                 if(FAILED(hrc))
                 {
@@ -1958,5 +1958,5 @@
 #if !defined(RT_OS_WINDOWS) && defined(VBOX_WITH_NETFLT)
                 Bstr HifName;
-                hrc = networkAdapter->COMGETTER(HostOnlyInterface)(HifName.asOutParam());
+                hrc = networkAdapter->COMGETTER(HostInterface)(HifName.asOutParam());
                 if(FAILED(hrc))
                 {
Index: trunk/src/VBox/Main/NetworkAdapterImpl.cpp
===================================================================
--- trunk/src/VBox/Main/NetworkAdapterImpl.cpp	(revision 18828)
+++ trunk/src/VBox/Main/NetworkAdapterImpl.cpp	(revision 18829)
@@ -396,5 +396,5 @@
 }
 
-STDMETHODIMP NetworkAdapter::COMGETTER(HostOnlyInterface)(BSTR *aHostInterface)
+STDMETHODIMP NetworkAdapter::COMGETTER(HostInterface)(BSTR *aHostInterface)
 {
     CheckComArgOutPointerValid(aHostInterface);
@@ -405,10 +405,10 @@
     AutoReadLock alock (this);
 
-    mData->mHostOnlyInterface.cloneTo (aHostInterface);
-
-    return S_OK;
-}
-
-STDMETHODIMP NetworkAdapter::COMSETTER(HostOnlyInterface)(IN_BSTR aHostInterface)
+    mData->mHostInterface.cloneTo (aHostInterface);
+
+    return S_OK;
+}
+
+STDMETHODIMP NetworkAdapter::COMSETTER(HostInterface)(IN_BSTR aHostInterface)
 {
     /** @todo Validate input string length. r=dmik: do it in XML schema?*/
@@ -427,53 +427,8 @@
     AutoWriteLock alock (this);
 
-    if (mData->mHostOnlyInterface != aHostInterface)
-    {
-        mData.backup();
-        mData->mHostOnlyInterface = aHostInterface;
-
-        /* leave the lock before informing callbacks */
-        alock.unlock();
-
-        mParent->onNetworkAdapterChange (this);
-    }
-
-    return S_OK;
-}
-
-STDMETHODIMP NetworkAdapter::COMGETTER(BridgedInterface)(BSTR *aHostInterface)
-{
-    CheckComArgOutPointerValid(aHostInterface);
-
-    AutoCaller autoCaller (this);
-    CheckComRCReturnRC (autoCaller.rc());
-
-    AutoReadLock alock (this);
-
-    mData->mBridgedInterface.cloneTo (aHostInterface);
-
-    return S_OK;
-}
-
-STDMETHODIMP NetworkAdapter::COMSETTER(BridgedInterface)(IN_BSTR aHostInterface)
-{
-    /** @todo Validate input string length. r=dmik: do it in XML schema?*/
-
-    /* we don't allow null strings for the host interface (because the @name
-     * attribute of <HostInterface> must be always present but can be empty). */
-    CheckComArgNotNull (aHostInterface);
-
-    AutoCaller autoCaller (this);
-    CheckComRCReturnRC (autoCaller.rc());
-
-    /* the machine needs to be mutable */
-    Machine::AutoMutableStateDependency adep (mParent);
-    CheckComRCReturnRC (adep.rc());
-
-    AutoWriteLock alock (this);
-
-    if (mData->mBridgedInterface != aHostInterface)
-    {
-        mData.backup();
-        mData->mBridgedInterface = aHostInterface;
+    if (mData->mHostInterface != aHostInterface)
+    {
+        mData.backup();
+        mData->mHostInterface = aHostInterface;
 
         /* leave the lock before informing callbacks */
@@ -971,5 +926,5 @@
         ComAssertRet (!name.isNull(), E_FAIL);
 
-        rc = COMSETTER(BridgedInterface) (name);
+        rc = COMSETTER(HostInterface) (name);
         CheckComRCReturnRC (rc);
 
@@ -997,5 +952,5 @@
         ComAssertRet (!name.isNull(), E_FAIL);
 
-        rc = COMSETTER(HostOnlyInterface) (name);
+        rc = COMSETTER(HostInterface) (name);
         CheckComRCReturnRC (rc);
 #endif
@@ -1089,6 +1044,6 @@
         {
             Key attachmentNode = aAdapterNode.createKey ("BridgedInterface");
-            Assert (!mData->mBridgedInterface.isNull());
-            attachmentNode.setValue <Bstr> ("name", mData->mBridgedInterface);
+            Assert (!mData->mHostInterface.isNull());
+            attachmentNode.setValue <Bstr> ("name", mData->mHostInterface);
             break;
         }
@@ -1104,6 +1059,6 @@
             Key attachmentNode = aAdapterNode.createKey ("HostOnlyInterface");
 #if defined(VBOX_WITH_NETFLT)
-            Assert (!mData->mHostOnlyInterface.isNull());
-            attachmentNode.setValue <Bstr> ("name", mData->mHostOnlyInterface);
+            Assert (!mData->mHostInterface.isNull());
+            attachmentNode.setValue <Bstr> ("name", mData->mHostInterface);
 #endif
             break;
@@ -1256,5 +1211,5 @@
         {
             /* reset handle and device name */
-            mData->mBridgedInterface = "";
+            mData->mHostInterface = "";
             break;
         }
@@ -1268,5 +1223,5 @@
 #if defined(VBOX_WITH_NETFLT)
             /* reset handle and device name */
-            mData->mHostOnlyInterface = "";
+            mData->mHostInterface = "";
 #endif
             break;
Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 18828)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 18829)
@@ -10933,5 +10933,5 @@
   <interface
      name="INetworkAdapter" extends="$unknown"
-     uuid="50F03B9E-FF02-4e07-9DA8-86FBF884D62E"
+     uuid="65607a27-2b73-4d43-b4cc-0ba2c817fbde"
      wsmap="managed"
      >
@@ -10982,16 +10982,10 @@
     <attribute name="attachmentType" type="NetworkAttachmentType" readonly="yes"/>
 
-    <attribute name="bridgedInterface" type="wstring">
-      <desc>
-        Name of the bridged network interface the VM is attached to.
-      </desc>
-    </attribute>
-    
-    <attribute name="hostOnlyInterface" type="wstring">
-      <desc>
-        Name of the host only network interface the VM is attached to.
-      </desc>
-    </attribute>
-    
+    <attribute name="hostInterface" type="wstring">
+      <desc>
+        Name of the host network interface the VM is attached to.
+      </desc>
+    </attribute>
+
     <attribute name="internalNetwork" type="wstring">
       <desc>
Index: trunk/src/VBox/Main/include/NetworkAdapterImpl.h
===================================================================
--- trunk/src/VBox/Main/include/NetworkAdapterImpl.h	(revision 18828)
+++ trunk/src/VBox/Main/include/NetworkAdapterImpl.h	(revision 18829)
@@ -44,6 +44,5 @@
             , mAttachmentType (NetworkAttachmentType_Null)
             ,  mCableConnected (TRUE), mLineSpeed (0), mTraceEnabled (FALSE)
-            , mHostOnlyInterface ("") /* cannot be null */
-            , mBridgedInterface ("") /* cannot be null */
+            , mHostInterface ("") /* cannot be null */
         {}
 
@@ -58,6 +57,5 @@
                     mLineSpeed == that.mLineSpeed &&
                     mTraceEnabled == that.mTraceEnabled &&
-                    mHostOnlyInterface == that.mHostOnlyInterface &&
-                    mBridgedInterface == that.mBridgedInterface &&
+                    mHostInterface == that.mHostInterface &&
                     mInternalNetwork == that.mInternalNetwork &&
                     mNATNetwork == that.mNATNetwork);
@@ -73,6 +71,5 @@
         BOOL mTraceEnabled;
         Bstr mTraceFile;
-        Bstr mHostOnlyInterface;
-        Bstr mBridgedInterface;
+        Bstr mHostInterface;
         Bstr mInternalNetwork;
         Bstr mNATNetwork;
@@ -112,8 +109,6 @@
     STDMETHOD(COMSETTER(MACAddress)) (IN_BSTR aMACAddress);
     STDMETHOD(COMGETTER(AttachmentType)) (NetworkAttachmentType_T *aAttachmentType);
-    STDMETHOD(COMGETTER(HostOnlyInterface)) (BSTR *aHostInterface);
-    STDMETHOD(COMSETTER(HostOnlyInterface)) (IN_BSTR aHostInterface);
-    STDMETHOD(COMGETTER(BridgedInterface)) (BSTR *aHostInterface);
-    STDMETHOD(COMSETTER(BridgedInterface)) (IN_BSTR aHostInterface);
+    STDMETHOD(COMGETTER(HostInterface)) (BSTR *aHostInterface);
+    STDMETHOD(COMSETTER(HostInterface)) (IN_BSTR aHostInterface);
     STDMETHOD(COMGETTER(InternalNetwork)) (BSTR *aInternalNetwork);
     STDMETHOD(COMSETTER(InternalNetwork)) (IN_BSTR aInternalNetwork);